## scipy 1.10.1

=== scipy/_lib/highs/CMakeLists.txt ===
# The top-level CMake file is there to bring all modules into scope. That
# means, adding the subdirectories for all CMake projects in this tree, and
# finding external libraries and turning them into imported targets.

cmake_minimum_required(VERSION 3.15)

# set preference for clang compiler and intel compiler over gcc and other compilers
include(Platform/${CMAKE_SYSTEM_NAME}-Determine-C OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-C OPTIONAL)
set(CMAKE_C_COMPILER_NAMES clang icc cc ${CMAKE_C_COMPILER_NAMES})

include(Platform/${CMAKE_SYSTEM_NAME}-Determine-CXX OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-CXX OPTIONAL)
set(CMAKE_CXX_COMPILER_NAMES clang++ icpc c++ ${CMAKE_CXX_COMPILER_NAMES})

# set default build type before project call, as it otherwise seems to fail for some plattforms
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RELEASE)
endif()

project(HIGHS VERSION 1.2 LANGUAGES CXX C)
set(HIGHS_VERSION_PATCH 2)

# use C++11 standard
set(CMAKE_CXX_STANDARD 11)

# use customizable install directories
include(GNUInstallDirs)

### Require out-of-source builds
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
    message(FATAL_ERROR "You cannot build in a source directory (or any directory with a CMakeLists.txt file).
    Please make a build subdirectory. Feel free to remove CMakeCache.txt and CMakeFiles.")
endif()

option(BUILD_TESTING "Build Tests" ON)

if(LINUX AND NOT MSVC)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported OUTPUT error)

    if(ipo_supported)
        message(STATUS "IPO / LTO enabled")
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
    else()
        message(STATUS "IPO / LTO not supported: <${error}>")
    endif()
endif()

# Fast build: No interfaces (apart from c); No ipx; New (short) ctest instances,
# static library and exe without PIC. Used for gradually updating the CMake
# targets build and install / export.

# Note: ON by default yet
option(FAST_BUILD "Fast build: only build static lib and exe and quick test." OFF)
option(FORTRAN "Build Fortran interface" OFF)
option(CSHARP "Build CSharp interface" OFF)

# set the correct rpath for OS X
set(CMAKE_MACOSX_RPATH ON)

option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Export all symbols into the DLL" ON)


set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})

include(CheckCXXSourceCompiles)

check_cxx_source_compiles(
    "#include <immintrin.h>
    int main () {
        _mm_pause();
        return 0;
    }"
    HIGHS_HAVE_MM_PAUSE)

if(MSVC)
    check_cxx_source_compiles(
        "#include <intrin.h>
        #pragma intrinsic(_BitScanReverse)
        #pragma intrinsic(_BitScanReverse64)
        int main () {
            unsigned long x = 5;
            unsigned long y;
            _BitScanReverse(&y, x);
            _BitScanReverse64(&x, y);
            return 0;
        }"
        HIGHS_HAVE_BITSCAN_REVERSE)
else()
    check_cxx_source_compiles(
        "#include <cstdint>
         int main () {
            unsigned int x = 5;
            unsigned long long y = __builtin_clz(x);
            x = __builtin_clzll(y);
            return 0;
        }"
        HIGHS_HAVE_BUILTIN_CLZ)
endif()

include(CheckCXXCompilerFlag)

if (NOT FAST_BUILD)
# Function to set compiler flags on and off easily.
function(enable_cxx_compiler_flag_if_supported flag)
    string(FIND "${CMAKE_CXX_FLAGS}" "${flag}" flag_already_set)
    if(flag_already_set EQUAL -1)
        check_cxx_compiler_flag("${flag}" flag_supported)
        if(flag_supported)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}" PARENT_SCOPE)
        endif()
        unset(flag_supported CACHE)
    endif()
endfunction()

# usage: turn pedantic on for even more warnings.
enable_cxx_compiler_flag_if_supported("-Wall")
enable_cxx_compiler_flag_if_supported("-Wextra")
enable_cxx_compiler_flag_if_supported("-Wno-unused-parameter")
enable_cxx_compiler_flag_if_supported("-Wno-format-truncation")
enable_cxx_compiler_flag_if_supported("-pedantic")
endif()

option(DEBUGSOL "check the debug solution" OFF)

if(DEBUGSOL)
  add_definitions("-DHIGHS_DEBUGSOL")
endif()

option(HIGHSINT64 "Use 64 bit integers indexing" OFF)
if (NOT (${HIGHSINT64} STREQUAL  "OFF"))
    message(STATUS "HIGHSINT64: " ${HIGHSINT64})
endif()

# If Visual Studio targets are being built.
if(MSVC)
    add_definitions(/W4)
    add_definitions(/wd4018 /wd4061 /wd4100 /wd4101 /wd4127 /wd4189 /wd4244 /wd4245 /wd4267 /wd4324 /wd4365 /wd4389 /wd4456 /wd4457 /wd4458 /wd4459 /wd4514 /wd4701 /wd4820)
    add_definitions(/MP)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_ITERATOR_DEBUG_LEVEL=0)
endif()

if (NOT FAST_BUILD OR FORTRAN)
include(CheckLanguage)
if(NOT MSVC)
    check_language("Fortran")
endif()
if(CMAKE_Fortran_COMPILER)
    enable_language(Fortran)
    set(FORTRAN_FOUND ON)
else()
    set(FORTRAN_FOUND OFF)
endif(CMAKE_Fortran_COMPILER)
endif()

if (NOT FAST_BUILD OR CSHARP)
check_language("CSharp")
if(CMAKE_CSharp_COMPILER)
    enable_language(CSharp)
    set(CSHARP_FOUND ON)
else()
    set(CSHARP_FOUND OFF)
endif(CMAKE_CSharp_COMPILER)
endif()

check_cxx_compiler_flag("-fno-omit-frame-pointer" NO_OMIT_FRAME_POINTER_FLAG_SUPPORTED)
if(NO_OMIT_FRAME_POINTER_FLAG_SUPPORTED)
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE} -fno-omit-frame-pointer")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE} -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer")
else()
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE}")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE}")
endif()

# uncomment for memory debugging
# set (CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fno-omit-frame-pointer -fsanitize=address -fsanitize=undefined")
# set (CMAKE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_LINKER_FLAGS_RELWITHDEBINFO} -fno-omit-frame-pointer -fsanitize=address -fsanitize=undefined")
# set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=address -fsanitize=undefined")
# set (CMAKE_LINKER_FLAGS_DEBUG "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=address -fsanitize=undefined")

# if zlib is found, then we can enable reading zlib-compressed input
find_package(ZLIB 1.2.3)

include(CPack)
set(CPACK_RESOURCE_FILE_LICENSE "${HIGHS_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${HIGHS_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${HIGHS_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${HIGHS_VERSION_PATCH}")
set(CPACK_PACKAGE_VENDOR "University of Edinburgh")

find_program(GIT git)
if((GIT) AND (EXISTS ${HIGHS_SOURCE_DIR}/.git))
    execute_process(
        COMMAND ${GIT} describe --always --dirty
        WORKING_DIRECTORY ${HIGHS_SOURCE_DIR}
        OUTPUT_VARIABLE GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
    string(REGEX REPLACE "^.*-g" "" GITHASH ${GITHASH})
else()
    set(GITHASH "n/a")
endif()
message(STATUS "Git hash: " ${GITHASH})

string(TIMESTAMP TODAY "%Y-%m-%d")
message(STATUS "Compilation date: " ${TODAY})

if (NOT FAST_BUILD)

# For the moment keep above coverage part in case we are testing at CI.
option(CI "CI extended tests" ON)

# Coverage part
# 'make coverage' to start the coverage process
option(HIGHS_COVERAGE "Activate the code coverage compilation" OFF)
if (HIGHS_COVERAGE)
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG}    -O0 --coverage")
    set(CMAKE_CXX_FLAGS_DEBUG  "${CMAKE_CXX_FLAGS_DEBUG}  -O0 --coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -O0 --coverage")
  endif ()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   -fprofile-arcs -ftest-coverage -Xclang -coverage-cfg-checksum -Xclang -coverage-no-function-names-in-data -Xclang -coverage-version='408*'")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage -Xclang -coverage-cfg-checksum -Xclang -coverage-no-function-names-in-data -Xclang -coverage-version='408*'")
  endif ()
endif ()

if (HIGHS_COVERAGE)
  if (NOT CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    message(FATAL_ERROR "Warning: to enable coverage, you must compile in DEBUG mode")
  endif ()
endif ()

if (HIGHS_COVERAGE)
  if (WIN32)
    message(FATAL_ERROR "Error: code coverage analysis is only available under Linux for now.")
  endif ()

  find_program(GCOV_PATH gcov)
  find_program(LCOV_PATH lcov)
  find_program(GENHTML_PATH genhtml)

  if (NOT GCOV_PATH)
    message(FATAL_ERROR "gcov not found! Please install lcov and gcov. Aborting...")
  endif ()

  if (NOT LCOV_PATH)
    message(FATAL_ERROR "lcov not found! Please install lcov and gcov. Aborting...")
  endif ()

  if (NOT GENHTML_PATH)
    message(FATAL_ERROR "genhtml not found! Please install lcov and gcov. Aborting...")
  endif ()

  # Capturing lcov counters and generating report
  if (NOT CI)
    add_custom_target(coverage
                    COMMAND ${LCOV_PATH} --directory ${CMAKE_BINARY_DIR} --zerocounters
                    COMMAND ${LCOV_PATH} --capture --initial --directory ${CMAKE_BINARY_DIR}/bin --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${CMAKE_CTEST_COMMAND} -LE "(LONG|FAIL)" || true
                    COMMAND ${LCOV_PATH} --capture --directory ${CMAKE_BINARY_DIR}/bin --directory ${CMAKE_BINARY_DIR}/src --directory ${CMAKE_BINARY_DIR}/app --directory ${CMAKE_BINARY_DIR}/check --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${LCOV_PATH} --remove "*/usr/include/*" --output-file ${CMAKE_BINARY_DIR}/coverage.info.cleaned
                    COMMAND ${GENHTML_PATH} -o ${CMAKE_BINARY_DIR}/coverage ${CMAKE_BINARY_DIR}/coverage.info.cleaned
                    COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_BINARY_DIR}/coverage.info.cleaned
            VERBATIM
                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                    COMMENT "Resetting code coverage counters to zero.
    Processing code coverage counters and generating report.
    You can zip the directory ${CMAKE_BINARY_DIR}/coverage and upload the content to a web server.")
  else()
    add_custom_target(ci_cov
                    COMMAND ${LCOV_PATH} --directory ${CMAKE_BINARY_DIR} --zerocounters
                    COMMAND ${LCOV_PATH} --capture --initial --directory ${CMAKE_BINARY_DIR}/bin --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${CMAKE_CTEST_COMMAND} -LE "(LONG|FAIL)" || true
                    COMMAND ${LCOV_PATH} --capture --directory ${CMAKE_BINARY_DIR}/bin --directory ${CMAKE_BINARY_DIR}/src --directory ${CMAKE_BINARY_DIR}/app --directory ${CMAKE_BINARY_DIR}/check --output-file ${CMAKE_BINARY_DIR}/coverage.info
		    VERBATIM
                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                    COMMENT "Resetting code coverage counters to zero.")
  endif()
endif ()

if(NOT MSVC)
    set(OSI_ROOT "" CACHE PATH "Osi root folder.")
    if (NOT "${OSI_ROOT}" STREQUAL "")
        # if OSI_ROOT is set, then overwrite PKG_CONFIG_PATH
        message(STATUS "OSI root folder set: " ${OSI_ROOT})
        set(ENV{PKG_CONFIG_PATH}  "${OSI_ROOT}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    endif ()
    unset(OSI_ROOT CACHE)
    find_package(PkgConfig)

    if(PKG_CONFIG_FOUND)
        pkg_check_modules(OSI osi)
        if (OSI_FOUND)
            # need to come before adding any targets (add_executable, add_library)

=== debian/changelog ===
scipy (1.10.1-2) unstable; urgency=medium

  * Team upload.
  * armhf with openblas: skip test_L3
    test_svd_return_singular_vectors[shape1-True]
    test_m_gt_n test_pteqr test_SR1_skip_update
    test_symmetric_starting_vector
  * hppa: skip test_bootstrap_against_theory (not enough memory)
  * x32: skip test_sample (test_qmc.py)

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Mar 2023 15:41:11 +0100

scipy (1.10.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - bug fixes and stability improvements.
      Upload for bookworm (Bug#1032073).
    - applies debian patches
      find_cython3.patch
      fix_cast_PR17726.patch
      fix_highs_atomic_PR17777.patch
      pythran_type_PR16646.patch
      readonly_interpolate_PR17717.patch
  * allow optional VERSION argument for debian/get-submodules
    gbp import-orig, for instance, needs the submodule source to be
    already downloaded (before reported in debian/changelog).
    Submodule source is generated strictly for the indicated version
    if the git tag v$VERSION is available, otherwise git HEAD is used.
    - document submodule handling in debian/README.source.
    - note that get-submodules requires rsync
  * debian/copyright: add entry for submodules/scipy/_lib/boost
    License: Boost-1.0, 2008 John Maddock (boost/math) and other
    contributors. scipy only uses boost/math, the submodule will be
    simplified to booth_math in the future (upstream PR#17432).
  * x32: skip test_random_generator during build
  * riscv64 with atlas: skip runtime test test_aligned_mem
  * debian patch docs_privacy.patch deactivates net analytics sent to
    views.scientific-python.org. The site itself respects privacy, but
    traffic monitoring in the middle might breach privacy.
  * some dataset tests require internet: test_existence_all
    test_ascent test_face test_electrocardiogram.
    Run them separately in debian/tests/python3-network.

 -- Drew Parsons <dparsons@debian.org>  Tue, 28 Feb 2023 22:38:09 +0100

scipy (1.10.0-12) unstable; urgency=medium

  * Team upload.
  * x32: skip test_bounds during build
  * armhf with openblas: skip intermittently failing tests
    test_random_complex_exact test_L7 test_sygst
    test_various_drivers_standard test_various_drivers_generalized
    test_broyden1 test_broyden2 test_gejsv_general
    test_BFGS_skip_update test_tolerance_float32

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Feb 2023 16:12:32 +0100

scipy (1.10.0-11) unstable; urgency=medium

  * Team upload.
  * x32: skip test_1sample during build
  * armhf with openblas: skip more failing tests.
    test_tpqrt_tpmqrt test_cossin_separate test_orcsd_uncsd
    test_eigs_consistency[20-0.001] test_random_initial_float32
    test_pdist_out test_lsqr_basic test_pascal test_atol_rtol

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Feb 2023 22:45:22 +0100

scipy (1.10.0-10) unstable; urgency=medium

  * Team upload.
  * x32: skip test_0sample during build
  * armhf with openblas: arch is flaky, tests fail intermittently.
    Skip test_cdist_out test_cdist_calling_conventions
    test_orcsd_uncsd[float64] test_L1 test_L4
    test_random_exact test_random_tall_left test_random_tall_right
    test_svd_random_state_2[random_state test_svd_random_state_3
    test_svd_linop test_ElasticRod
    test_small_sigma_sparse[float32-shape1] test_small_sigma2[float]
    test_interpolation_misfit_1d test_svds_parameter_k_which[LM-5]
    test_Small test_failure_to_run_iterations
    test_precond_inverse[case1] test_examples
  * Consider using armhf with atlas or blis, not openblas.

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Feb 2023 10:34:17 +0100

scipy (1.10.0-9) unstable; urgency=medium

  * Team upload.
  * x32: skip test_0dim during build
  * armhf with openblas: skip failing sparse.linalg runtime tests
    eigen/lobpcg: test_MikotaPair test_diagonal[100-4-3] test_maxit
    eigen/svds: test_svd_random_state_3[random_state*
    isolve: test_precond_inverse[case1]
    propack: test_examples

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Feb 2023 19:36:32 +0100

=== debian/control ===
Source: scipy
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Ondrej Certik <ondrej@certik.cz>,
           David Cournapeau <cournape@gmail.com>,
           Varun Hiremath <varun@debian.org>
Section: python
Priority: optional
Build-Depends: cython3 (>= 0.29.21~),
               cython3 (<< 3.0),
               debhelper-compat (= 13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               gfortran,
               libblas-dev,
               liblapack-dev,
               liblbfgsb-dev,
               libsuitesparse-dev,
               python3-mesonpy,
               pkg-config,
               python3-all-dev,
               python3-decorator,
               python3-numpy (>= 1:1.21.4),
               python3-pooch,
               python3-pybind11 (>= 2.4.3),
               python3-pytest,
               python3-setuptools,
               python3-wheel,
               python3-pythran,
               python3-pythran (<< 0.13) [!armhf]
Build-Depends-Indep: dvipng,
                     dh-sequence-sphinxdoc,
                     python3-doc,
                     python3-docutils,
                     python3-matplotlib,
                     python3-numpydoc,
                     python3-pydata-sphinx-theme,
                     python3-sphinx,
                     python3-sphinx-panels,
                     python3-sphinx-tabs,
                     rdfind,
                     symlinks,
                     texlive-latex-base,
                     texlive-latex-extra
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/python-team/packages/scipy
Vcs-Git: https://salsa.debian.org/python-team/packages/scipy.git
Homepage: https://www.scipy.org/
Rules-Requires-Root: no

Package: python3-scipy
Architecture: any
Multi-Arch: foreign
Depends: python3-decorator,
         python3-numpy (>= 1:1.17.3~),
         python3-pythran [!armhf],
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: g++ | c++-compiler,
            python3-pil
Suggests: python-scipy-doc
Breaks: python3-skbio (<< 0.5.8-3~)
Description: scientific tools for Python 3
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.

Package: python-scipy-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-open-sans,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: scientific library for Python - documentation
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package contains documentation for the SciPy library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/architecture.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)
export SCIPY_USE_PYTHRAN=0

PY3VERS:= $(shell py3versions -v -s)
PY3_DEFAULT:= $(shell py3versions -dv)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

export SCIPY_USE_PYTHRAN = $(shell if dpkg-query -s python3-pythran >/dev/null 2>/dev/null; then echo 1; else echo 0; fi )

# specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
# by the end user, not by the package build.
export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack

# stats/tests/test_continuous_basic.py::test_cont_basic[500-200-ncf-arg74] test fails with IntegrationWarning
# https://github.com/scipy/scipy/issues/14519
# test_data (pooch) needs internet or cached data files
SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# linalg/tests/test_decomp.py started segfaulting on armel
ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist
endif

# some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
    SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0]
endif

# Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
SKIP_KOLMOGOROV_ARCH_LIST := i386 hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_KOLMOGOROV_ARCH_LIST)$(space)))
  SKIP_TEST_LIST += TestSmirnovp
endif

# integrate/_ivp/tests/test_ivp.py fail on mips64el
# see https://github.com/scipy/scipy/issues/16883
# https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
    SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), mipsel))
    SKIP_TEST_LIST += test_NaN_warnings test_moments_warnings test_fht_special_cases test_integrality test_integrator test_double_integrator
endif

# hppa runs out of memeory in test_bootstrap_against_theory
ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory
endif

# powerpc: failures in stats/tests/test_stats.py: overflow encountered in _hypergeom_*
ifneq (,$(findstring $(DEB_HOST_ARCH), powerpc))
    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise test_less_greater test_maxiter_worsening[lgmres]
endif

# test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
# so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg]
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), hurd-i386))
    SKIP_TEST_LIST += test_mip1 test_find_peaks_exact test_find_peaks_withnoise test_examples[True-float64] test_rv_sample test_location_scale[pdf
    SKIP_TEST_LIST += test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0]
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), ia64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1399478853
ifneq (,$(findstring $(DEB_HOST_ARCH), ppc64))
    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres]
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), x32))
    SKIP_TEST_LIST += test_input_validation test_basic test_sign test_flexible_input \
	test_perm_discrepancy test_integers_nd test_0dim test_0sample test_1sample \
	test_bounds test_random_generator test_sample
endif

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_clean:
	rm -rf build .pybuild
	-find $(CURDIR) -name __pycache__ -type d -exec rm -rf {} +
	-rm -rf doc/source/fontList*
	-rm -rf doc/source/reference/generated
	-rm -rf doc/build

execute_before_dh_clean:
	# make sure symlinks to submodules are cleaned up or empty directories from tarball are removed
	rm -rf doc/source/_static/scipy-mathjax
	rm -rf scipy/_lib/boost
	rm -rf scipy/_lib/highs
	rm -rf scipy/_lib/unuran
	rm -rf scipy/sparse/linalg/_propack/PROPACK

execute_before_dh_auto_configure:
	echo "Symlink to submodules"
	ln -sf ../../../submodules/doc/source/_static/scipy-mathjax		doc/source/_static/scipy-mathjax
	ln -sf ../../submodules/scipy/_lib/boost				scipy/_lib/boost
	ln -sf ../../submodules/scipy/_lib/highs				scipy/_lib/highs
	ln -sf ../../submodules/scipy/_lib/unuran				scipy/_lib/unuran
	ln -sf ../../../../submodules/scipy/sparse/linalg/_propack/PROPACK	scipy/sparse/linalg/_propack/PROPACK
	echo "Building scipy with SCIPY_USE_PYTHRAN=$(SCIPY_USE_PYTHRAN)"

execute_before_dh_installdocs-indep:
	(export MPLCONFIGDIR=. ; \
	PYLIBPATH=`pybuild --print build_dir -p$(PY3_DEFAULT) | awk '{print $$3}'`; \
	echo "building docs using PYLIBPATH=$$PYLIBPATH"; \
	PYTHONPATH=$$PYLIBPATH make -C doc html PYTHONPATH=$$PYLIBPATH PYVER=3) || /bin/true

override_dh_auto_test:
	echo "Build-time tests will be run after the installation dir is installed"

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_install:
	set -e; \
	SKIP_TESTS=""; \
	list_initialised=0; \
	for t in $(SKIP_TEST_LIST); do \
	    if [ $${list_initialised} = 0 ]; then \
	        SKIP_TESTS=$$t; \
	        list_initialised=1; \
	    else \
	        SKIP_TESTS="$${SKIP_TESTS} or $$t"; \
	    fi; \
	done; \
	if [ "x$${SKIP_TESTS}" != "x" ]; then \
	    SKIP_TESTS="not ( $${SKIP_TESTS} )"; \
	fi; \
	echo "skipping tests: $${SKIP_TESTS}"; \
	for py in $(PY3VERS); do \
	  PYLIBPATH=`pybuild --print build_dir -p$$py | awk '{print $$3}'`; \
	  PYTHONPATH=$$PYLIBPATH python$$py \
	        $(CURDIR)/runtests.py -n -- -k "$${SKIP_TESTS}"; \
	done
endif

execute_after_dh_install:
	dh_numpy3


# meson build is still work-in-progress, installs residual cython (pyx) files
# See cython_special comments in scipy/special/meson.build
# and https://github.com/scipy/scipy/issues/14890
# In the meantime clean up python3.X (not python3) files left after dh_python3
execute_after_dh_python3:
	rm -rf debian/python3-scipy/usr/lib/python$(PY3_DEFAULT)

=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev, python3-pil, python3-pooch

Tests: python3-network
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev, python3-pil, python3-pooch
Restrictions: needs-internet

# short test on all python versions including debug
Tests: python3-smoke
Depends: python3-scipy, python3-pytest, python3-all

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: openblas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el riscv64 sparc64 s390x

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: atlas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libatlas-base-dev

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: blis
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libblis-dev

## scipy 1.11.4

=== scipy/sparse/linalg/_propack/PROPACK/single/Lapack_Util/Makefile ===
#
#     (C) Rasmus Munk Larsen, Stanford University, 2004
#

include ../../make.inc
OBJ = sbdsdc.o  slamrg.o  slascl.o  slasd4.o  slasda.o  slasq2.o  slasr.o  \
ilaenv.o sbdsqr.o  slanst.o  slasd0.o  slasd5.o  slasdq.o  slasq3.o  slasrt.o \
lsame.o  slacpy.o  slapy2.o  slasd1.o  slasd6.o  slasdt.o  slasq4.o  slassq.o \
slaed6.o slartg.o  slasd2.o  slasd7.o  slaset.o  slasq5.o  slasv2.o \
slas2.o  slasd3.o  slasd8.o  slasq1.o  slasq6.o  \
ieeeck.o slartg.o  slarnv.o  slaruv.o  slamch.o xerbla.o 

.F.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.F

.f.o:
	$(F77) $(FFLAGS) $(IPATH) -c -o $*.o $*.f

slamch.o: slamch.f
	$(F77)	$(FFLAGS_NOOPT) $(IPATH) -c -o $*.o $*.f

ieeeck.o: ieeeck.f
	$(F77)	$(FFLAGS_NOOPT) $(IPATH) -c -o $*.o $*.f

ilaenv.o: ilaenv.f
	$(F77)	$(FFLAGS_NOOPT) $(IPATH) -c -o $*.o $*.f

slasd4.o: slasd4.f
	$(F77)	$(FFLAGS_ACCURATE) $(IPATH) -c -o $*.o $*.f


lib: ../libslapack_util_$(PLAT).a

../libslapack_util_$(PLAT).a: $(OBJ)
	$(MAKELIB) libslapack_util_$(PLAT).a $(OBJ)	
	$(RANLIB)  libslapack_util_$(PLAT).a
	mv libslapack_util_$(PLAT).a ..

clean:
	rm -f  *.o *.il 
	rm -rf rii_files	

cleanall:
	rm -f  *.o *.x *.a *~ *.il ifc*
	rm -rf rii_files

=== debian/changelog ===
scipy (1.11.4-10deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:18:14 +0800

scipy (1.11.4-10) unstable; urgency=medium

  * Team upload.
  * update debian/tests
    - test default python only on riscv64 to avoid timeout
    - drop atlas BLAS tests, since atlas is deprecated (Bug#1070013),
      times out on riscv64 and fails specific tests elsewhere
    - report durations of slowest 20 tests

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 May 2024 20:23:08 +0200

scipy (1.11.4-9) unstable; urgency=medium

  * Team upload.
  * debian/tests: fix handling of verbose flag (used for riscv64)

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 May 2024 18:49:39 +0200

scipy (1.11.4-8) unstable; urgency=medium

  * Team upload.
  * multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
    see https://github.com/scipy/scipy/pull/18541
    It fails tests now so skip test_multiple_ellipsis_slicing
    and reinstate later for scipy 1.13. Closes: #1069377.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 May 2024 18:41:16 +0200

scipy (1.11.4-7) unstable; urgency=medium

  * Team upload.
  * skip build-time tests
    - hppa: test_onenormest_linear_operator
      test_against_anderson_gumbel_r
      test_gh12218 test_bootstrap_against_R
      bootstrap_against_itself_1samp[basic-1780]
      test_bootstrap_against_itself_1samp[percentile-1784]
      test_bootstrap_against_itself_1samp[BCa-1784]
    - hurd-i386: test_ttest_many_dims

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 May 2024 15:43:21 +0200

scipy (1.11.4-6) unstable; urgency=medium

  * Team upload.
  * debian/tests: set default (empty) value of VERBOSE_TESTS
  * hurd-i386: skip test_gh12218

 -- Drew Parsons <dparsons@debian.org>  Fri, 23 Feb 2024 13:24:19 +0100

scipy (1.11.4-5) unstable; urgency=medium

  * Team upload.
  * skip build-time tests
    - hurd-i386: test_logpdf_pdf_consistency
    - ia64: test_examples[True-complex64] (test_propack)
    - sparc64: test_milp_timeout_16545
  * debian/tests: skip failing tests on i386
    - with atlas: test_propack
    - with blis: test_dtypes (in sparse/linalg test_lobpcg.py)
  * debian/tests: run riscv64 tests verbose (-v) to identify
    which tests are timing out, and skip test_maxiter_worsening[lgmres]
    to match debian/rules

 -- Drew Parsons <dparsons@debian.org>  Thu, 22 Feb 2024 17:20:19 +0100

scipy (1.11.4-4) unstable; urgency=medium

  * Team upload.
  * skip test_hermitian (scipy/linalg test_lobpcg) on i386
  * use EXTRA_TEST_FLAGS (-v) with hurd-i386, hppa and ia64 to
    identify which tests are failing

 -- Drew Parsons <dparsons@debian.org>  Mon, 19 Feb 2024 15:53:59 +0100

scipy (1.11.4-3) unstable; urgency=medium

  * Team upload.
  * skip test_gh12218 on armhf

 -- Drew Parsons <dparsons@debian.org>  Sun, 18 Feb 2024 10:20:50 +0100

scipy (1.11.4-2) unstable; urgency=medium

  * Team upload.
  * skip test_gh12218 on armel

 -- Drew Parsons <dparsons@debian.org>  Sat, 17 Feb 2024 09:49:20 +0100

scipy (1.11.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * skip tests. Closes: #1061605.
    - armel: test_some_code_paths (stats TestKSTwoSamples)
    - sparc64: test_distance_transform_cdt05 (ndimage)

 -- Drew Parsons <dparsons@debian.org>  Thu, 15 Feb 2024 14:19:46 +0100

scipy (1.11.1-1exp2) experimental; urgency=medium

  * Team upload.
  * update debian patch manage_tests.patch to use assert_allclose
    to compare floating point values in test_bootstrap_alternative in
    stats test_resampling.py. Needed on i386, see upstream Issue#20043.
  * skip failing tests
    - armel: test_sparse_dense_divide
    - i386: test_pdf_nolan_samples test_cdf_nolan_samples
    - mips64el: test_nanminmax
    - riscv64: test_milp_timeout_16545
    - s390x, hppa, powerpc, ppc64: test_distance_transform_cdt05
  * update Build-Depends: pkgconf rather than pkg-config

 -- Drew Parsons <dparsons@debian.org>  Thu, 08 Feb 2024 00:59:34 +0100

scipy (1.11.1-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - submodule _lib/boost renamed to _lib/boost_math
    - applies debian patch link_atomics_PR17777.patch
    - use -m pytest (build-time) and in-python scipy.tests() (runtime
      debian/tests) to run tests since runtests.py has been removed.
      Upstream now uses dev.py but it requires pydevtool, which is not
      yet packaged for debian (RFP Bug#1062827).
  * x32: skip test_continuing
  * report full tarball pathname in debian/get-submodules
    to ease file handling
  * drop deprecated debian patch docs_no_sphinx_design.patch
  * update versioned Build-Depends: python3-mesonpy (>= 0.12.1~),
      python3-numpy (>= 1:1.21.6~),
      python3-pybind11 (>= 2.10.4~),
      python3-pythran (>= 0.12.0~)
  * for docs, Build-Depends-Indep: python3-sphinx-design
    instead of python3-sphinx-panels,
  * debian patch cblas_in_blas.patch drops an explicit dependency on
    cblas (libcblas.so). On Debian the cblas symbols are built into
    libblas.so.
  * clean files generated by meson.build (see special/meson.build)
    Remove python3.* __config__.py, retain the one generated by the
    default python.
  * update debian patch manage_docs.patch to drop myst_nb
    (not yet packaged for debian)

 -- Drew Parsons <dparsons@debian.org>  Sun, 04 Feb 2024 13:03:07 +0100

scipy (1.10.1-10) unstable; urgency=medium

  * Team upload.
  * rewrite link_atomics_PR17777.patch to only test __atomic_add_fetch
    and drop __atomic_load_n. PR#17777 had actually already been
    applied, but gcc on armel does not define __atomic_load_n.
    see upstream issue #19982.

 -- Drew Parsons <dparsons@debian.org>  Sun, 28 Jan 2024 14:08:13 +0100

scipy (1.10.1-9) unstable; urgency=medium

  * Team upload.
  * debian patch link_atomics_PR17777.patch applies upstream PR#17777
    to link to atomics symbols where required (armel).



=== debian/control ===
--- 
+++ 
@@ -5,8 +5,7 @@
            Varun Hiremath <varun@debian.org>
 Section: python
 Priority: optional
-Build-Depends: cython3 (>= 0.29.21~),
-               cython3 (<< 3.0),
+Build-Depends: cython3-legacy,
                debhelper-compat (= 13),
                dh-sequence-python3,
                pybuild-plugin-pyproject,
@@ -15,18 +14,18 @@
                liblapack-dev,
                liblbfgsb-dev,
                libsuitesparse-dev,
-               python3-mesonpy,
-               pkg-config,
+               python3-mesonpy (>= 0.12.1~),
+               pkgconf,
                python3-all-dev,
                python3-decorator,
-               python3-numpy (>= 1:1.21.4),
+               python3-doit (>= 0.35~) <!nocheck>,
+               python3-numpy (>= 1:1.21.6~),
                python3-pooch,
-               python3-pybind11 (>= 2.4.3),
+               python3-pybind11 (>= 2.10.4~),
                python3-pytest,
                python3-setuptools,
                python3-wheel,
-               python3-pythran,
-               python3-pythran (<< 0.13) [!armhf]
+               python3-pythran (>= 0.12.0~)
 Build-Depends-Indep: dvipng,
                      dh-sequence-sphinxdoc,
                      python3-doc,
@@ -35,7 +34,7 @@
                      python3-numpydoc,
                      python3-pydata-sphinx-theme,
                      python3-sphinx,
-                     python3-sphinx-panels,
+                     python3-sphinx-design,
                      python3-sphinx-tabs,
                      rdfind,
                      symlinks,
@@ -52,7 +51,6 @@
 Multi-Arch: foreign
 Depends: python3-decorator,
          python3-numpy (>= 1:1.17.3~),
-         python3-pythran [!armhf],
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -30,19 +30,30 @@
 # test_data (pooch) needs internet or cached data files
 SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram
 
+# multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
+# see https://github.com/scipy/scipy/pull/18541
+# it fails tests now so skip and reinstate later for scipy 1.13
+SKIP_TEST_LIST += test_multiple_ellipsis_slicing
+
 ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
     SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
 endif
 
 # linalg/tests/test_decomp.py started segfaulting on armel
 ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
-    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist
+    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist test_sparse_dense_divide
+    SKIP_TEST_LIST += test_some_code_paths test_gh12218
+endif
+
+ifneq (,$(findstring $(DEB_HOST_ARCH), armhf))
+    SKIP_TEST_LIST += test_gh12218
 endif
 
 # some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
 ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
     SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
-    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0]
+    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples test_cdf_nolan_samples
+    SKIP_TEST_LIST += ellint_rg_xy0_ipp-ellint_rg_xy0 test_hermitian
 endif
 
 # Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
@@ -56,6 +67,7 @@
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
 ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
     SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
+    SKIP_TEST_LIST += test_nanminmax
 endif
 
 ifneq (,$(findstring $(DEB_HOST_ARCH), mipsel))
@@ -64,43 +76,55 @@
 
 # hppa runs out of memeory in test_bootstrap_against_theory
 ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
-    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory
+    EXTRA_TEST_FLAGS += -v
+    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory test_distance_transform_cdt05
+    SKIP_TEST_LIST += test_onenormest_linear_operator test_against_anderson_gumbel_r test_gh12218 test_bootstrap_against_R
+    SKIP_TEST_LIST += bootstrap_against_itself_1samp[basic-1780] test_bootstrap_against_itself_1samp[percentile-1784] test_bootstrap_against_itself_1samp[BCa-1784]
 endif
 
 # powerpc: failures in stats/tests/test_stats.py: overflow encountered in _hypergeom_*
 ifneq (,$(findstring $(DEB_HOST_ARCH), powerpc))
-    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise test_less_greater test_maxiter_worsening[lgmres]
+    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise
+    SKIP_TEST_LIST += test_less_greater test_maxiter_worsening[lgmres] test_distance_transform_cdt05
 endif
 
 # test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
 # so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
 ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
-    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg]
+    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg] test_distance_transform_cdt05
 endif
 
 ifneq (,$(findstring $(DEB_HOST_ARCH), hurd-i386))
+    EXTRA_TEST_FLAGS += -v
     SKIP_TEST_LIST += test_mip1 test_find_peaks_exact test_find_peaks_withnoise test_examples[True-float64] test_rv_sample test_location_scale[pdf
-    SKIP_TEST_LIST += test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0]
+    SKIP_TEST_LIST += test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0] ellint_rg_xy0_ipp-ellint_rg_xy0
+    SKIP_TEST_LIST += test_logpdf_pdf_consistency test_gh12218 test_ttest_many_dims
 endif
 
 ifneq (,$(findstring $(DEB_HOST_ARCH), ia64))
-    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
+    EXTRA_TEST_FLAGS += -v
+    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_examples[True-complex64]
 endif
 
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1399478853
 ifneq (,$(findstring $(DEB_HOST_ARCH), ppc64))
-    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres]
+    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres] test_distance_transform_cdt05
 endif
 
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
 ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
-    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
+    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_milp_timeout_16545
+endif
+
+ifneq (,$(findstring $(DEB_HOST_ARCH), sparc64))
+    SKIP_TEST_LIST += test_distance_transform_cdt05 test_milp_timeout_16545
 endif
 
 ifneq (,$(findstring $(DEB_HOST_ARCH), x32))
     SKIP_TEST_LIST += test_input_validation test_basic test_sign test_flexible_input \
 	test_perm_discrepancy test_integers_nd test_0dim test_0sample test_1sample \
-	test_bounds test_random_generator test_sample
+	test_bounds test_random_generator test_sample test_continuing \
+	test_svd_random_state_2 ellint_rg_xy0_ipp-ellint_rg_xy0 test_reset
 endif
 
 %:
@@ -116,7 +140,7 @@
 execute_before_dh_clean:
 	# make sure symlinks to submodules are cleaned up or empty directories from tarball are removed
 	rm -rf doc/source/_static/scipy-mathjax
-	rm -rf scipy/_lib/boost
+	rm -rf scipy/_lib/boost_math
 	rm -rf scipy/_lib/highs
 	rm -rf scipy/_lib/unuran
 	rm -rf scipy/sparse/linalg/_propack/PROPACK
@@ -124,7 +148,7 @@
 execute_before_dh_auto_configure:
 	echo "Symlink to submodules"
 	ln -sf ../../../submodules/doc/source/_static/scipy-mathjax		doc/source/_static/scipy-mathjax
-	ln -sf ../../submodules/scipy/_lib/boost				scipy/_lib/boost
+	ln -sf ../../submodules/scipy/_lib/boost_math				scipy/_lib/boost_math
 	ln -sf ../../submodules/scipy/_lib/highs				scipy/_lib/highs
 	ln -sf ../../submodules/scipy/_lib/unuran				scipy/_lib/unuran
 	ln -sf ../../../../submodules/scipy/sparse/linalg/_propack/PROPACK	scipy/sparse/linalg/_propack/PROPACK
@@ -158,18 +182,4 @@
 	echo "skipping tests: $${SKIP_TESTS}"; \
 	for py in $(PY3VERS); do \
 	  PYLIBPATH=`pybuild --print build_dir -p$$py | awk '{print $$3}'`; \
-	  PYTHONPATH=$$PYLIBPATH python$$py \
-	        $(CURDIR)/runtests.py -n -- -k "$${SKIP_TESTS}"; \
-	done
-endif
-
-execute_after_dh_install:
-	dh_numpy3
-
-
-# meson build is still work-in-progress, installs residual cython (pyx) files
-# See cython_special comments in scipy/special/meson.build
-# and https://github.com/scipy/scipy/issues/14890
-# In the meantime clean up python3.X (not python3) files left after dh_python3
-execute_after_dh_python3:
-	rm -rf debian/python3-scipy/usr/lib/python$(PY3_DEFAULT)
+	  (cd $$PYLIBPATH; \

=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev,
 python3-doit, python3-pil, python3-pooch

Tests: python3-network
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev,
 python3-doit, python3-pil, python3-pooch
Restrictions: needs-internet

# short test on all python versions including debug
Tests: python3-smoke
Depends: python3-scipy, python3-pytest, python3-all, python3-doit

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: openblas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, python3-doit,
 libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el riscv64 sparc64 s390x

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: blis
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, python3-doit,
 libblis-dev
